searchData={"items":[{"type":"module","title":"Funkspector","doc":"Funkspector is a web scraper that lets you extract data from web pages.","ref":"Funkspector.html"},{"type":"function","title":"Funkspector.page_scrape/2","doc":"Parses an HTML document.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.page_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its HTML contents:\n\n  Funkspector.page_scrape(\"https://example.com\", contents: \" ... \")","ref":"Funkspector.html#page_scrape/2"},{"type":"function","title":"Example: request a document - Funkspector.page_scrape/2","doc":"iex> { :ok, document } = Funkspector.page_scrape(\"https://jaimeiniesta.com\")\n    iex> Enum.take(document.data.links.http.external, 3)\n    [\"http://www.archive.elixirconf.eu/elixirconf2016\", \"https://steadyhq.com/\", \"https://stuart.com/\"]","ref":"Funkspector.html#page_scrape/2-example-request-a-document"},{"type":"function","title":"Example: site not found - Funkspector.page_scrape/2","doc":"iex> Funkspector.page_scrape(\"https://notfoundwebsite.com\")\n    {:error, \"https://notfoundwebsite.com\", %HTTPoison.Error{reason: :nxdomain, id: nil}}","ref":"Funkspector.html#page_scrape/2-example-site-not-found"},{"type":"function","title":"Funkspector.resolve/2","doc":"Given a URL, it will follow the redirections and return the final URL and the final response.","ref":"Funkspector.html#resolve/2"},{"type":"function","title":"Examples - Funkspector.resolve/2","doc":"iex> { :ok, final_url, _response } = Funkspector.resolve(\"http://github.com\")\n    iex> final_url\n    \"https://github.com/\"","ref":"Funkspector.html#resolve/2-examples"},{"type":"function","title":"Funkspector.scrape/3","doc":"","ref":"Funkspector.html#scrape/3"},{"type":"function","title":"Funkspector.sitemap_scrape/2","doc":"Parses an XML sitemap.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.sitemap_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its XML contents:\n\n  Funkspector.sitemap_scrape(\"https://example.com/sitemap.xml\", contents: \" ... \")","ref":"Funkspector.html#sitemap_scrape/2"},{"type":"function","title":"Example - Funkspector.sitemap_scrape/2","doc":"iex> { :ok, document } = Funkspector.sitemap_scrape(\"https://rocketvalidator.com/sitemap.xml\")\n    iex> length document.data.locs\n    1749\n    iex> Enum.take(document.data.locs, 3)\n    [\"https://rocketvalidator.com/\", \"https://rocketvalidator.com/html-validation\", \"https://rocketvalidator.com/accessibility-validation\"]","ref":"Funkspector.html#sitemap_scrape/2-example"},{"type":"function","title":"Funkspector.text_sitemap_scrape/2","doc":"Parses a text sitemap.\n\nThis can be used to request a document by passing its URL, like:\n\n  Funkspector.text_sitemap_scrape(\"https://example.com\")\n\nOr to scrape an already loaded document, by passing its text contents:\n\n  Funkspector.text_sitemap_scrape(\"https://example.com/sitemap.txt\", contents: \"...\")","ref":"Funkspector.html#text_sitemap_scrape/2"},{"type":"function","title":"Example - Funkspector.text_sitemap_scrape/2","doc":"iex> { :ok, document } = Funkspector.text_sitemap_scrape(\"https://rocketvalidator.com/sitemap.txt\")\n    iex> length document.data.lines\n    1749\n    iex> Enum.take(document.data.lines, 3)\n    [\"https://rocketvalidator.com/\", \"https://rocketvalidator.com/html-validation\", \"https://rocketvalidator.com/accessibility-validation\"]","ref":"Funkspector.html#text_sitemap_scrape/2-example"},{"type":"module","title":"Funkspector.Document","doc":"Defines the Document struct and functions to request or load its contents.","ref":"Funkspector.Document.html"},{"type":"function","title":"Funkspector.Document.load/2","doc":"Returns a document with the given url and contents.","ref":"Funkspector.Document.html#load/2"},{"type":"function","title":"Funkspector.Document.request/2","doc":"Retrieves the url and returns a document with its contents.","ref":"Funkspector.Document.html#request/2"},{"type":"module","title":"Funkspector.PageScraper","doc":"Scrapes an HTML page.","ref":"Funkspector.PageScraper.html"},{"type":"function","title":"Funkspector.PageScraper.scrape/1","doc":"Scrapes the Document contents and returns the data scraped from its HTML.","ref":"Funkspector.PageScraper.html#scrape/1"},{"type":"module","title":"Funkspector.Resolver","doc":"Provides a method to follow URL redirections, returning the final URL.","ref":"Funkspector.Resolver.html"},{"type":"function","title":"Funkspector.Resolver.resolve/2","doc":"Given a URL, it will follow the redirections and return the final URL and the final response.","ref":"Funkspector.Resolver.html#resolve/2"},{"type":"function","title":"Examples - Funkspector.Resolver.resolve/2","doc":"iex> { :ok, final_url, _response } = Funkspector.Resolver.resolve(\"http://github.com\")\n    iex> final_url\n    \"https://github.com/\"","ref":"Funkspector.Resolver.html#resolve/2-examples"},{"type":"module","title":"Funkspector.SitemapScraper","doc":"Scrapes an XML sitemap.","ref":"Funkspector.SitemapScraper.html"},{"type":"function","title":"Funkspector.SitemapScraper.scrape/1","doc":"Scrapes the Document contents and returns the data scraped from its XML.","ref":"Funkspector.SitemapScraper.html#scrape/1"},{"type":"module","title":"Funkspector.TextSitemapScraper","doc":"Scrapes a text sitemap.","ref":"Funkspector.TextSitemapScraper.html"},{"type":"function","title":"Funkspector.TextSitemapScraper.scrape/1","doc":"Scrapes the Document contents and returns the data scraped from the text lines.","ref":"Funkspector.TextSitemapScraper.html#scrape/1"},{"type":"module","title":"Funkspector.Utils","doc":"Common functionality for the scrapers.","ref":"Funkspector.Utils.html"},{"type":"function","title":"Funkspector.Utils.absolutify/2","doc":"Given a collection of URLs and a base URL, absolutifies the relative links.","ref":"Funkspector.Utils.html#absolutify/2"},{"type":"function","title":"Examples - Funkspector.Utils.absolutify/2","doc":"iex> Funkspector.Utils.absolutify([\"javascript:alert(hi)\", \"/faqs?section=legal\", \"/about\", \"http://example.com/faqs\"], \"http://example.com\")\n    [\"javascript:alert(hi)\", \"http://example.com/faqs?section=legal\", \"http://example.com/about\", \"http://example.com/faqs\"]","ref":"Funkspector.Utils.html#absolutify/2-examples"},{"type":"function","title":"Funkspector.Utils.valid_url?/1","doc":"Returns a boolean telling if the URL seems valid according to the regexp.","ref":"Funkspector.Utils.html#valid_url?/1"},{"type":"function","title":"Examples - Funkspector.Utils.valid_url?/1","doc":"iex> Funkspector.Utils.valid_url?(\"https://example.com\")\ntrue\n\niex> Funkspector.Utils.valid_url?(\"joe@example.com\")\nfalse\n\niex> Funkspector.Utils.valid_url?(nil)\nfalse\n\niex> Funkspector.Utils.valid_url?(\"  \")\nfalse","ref":"Funkspector.Utils.html#valid_url?/1-examples"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.0"}}